#! /bin/sh

# @param String message - The message to log
readonly LOG_MESSAGE_COMMAND=$(basename "${0}")
logMessage()
{
  echo "$(date '+%a %b %e %T %Y') TunnelBear $LOG_MESSAGE_COMMAND: "${@} >> "${SCRIPT_LOG_FILE}"
}

enableProxy()
{
  if [ "$ISENABLED" == "No" ]; then
    logMessage "Enabling proxy"
    networksetup -setwebproxy "$NETSET" 127.0.0.1 $PORT
    logMessage "Saving proxy interface: $NETSET"
    defaults write com.tunnelbear.mac.TunnelBear savedProxyInterface "$NETSET";
    logMessage `defaults read com.tunnelbear.mac.TunnelBear savedProxyInterface`
  fi

  logMessage `networksetup -getwebproxy "$NETSET"`
}

setProxyBypass()
{
  saveProxyBypassDomains
  networksetup -setproxybypassdomains "$NETSET" $DOMAINS
  logMessage `networksetup -getproxybypassdomains "$NETSET"`
}

saveProxyBypassDomains()
{
  logMessage "Saving current proxy bypass domains..."
  CDOMAINS=`networksetup -getproxybypassdomains "$NETSET"`

  logMessage "Current proxy bypass domains: $CDOMAINS"
  defaults write com.tunnelbear.mac.TunnelBear savedProxyBypassDomains "$CDOMAINS";
}

################# START HERE ####################

readonly SCRIPT_LOG_FILE="/var/log/tbeard/vigilant.log"

OPERATION="$1"

DEFAULT_INTERFACE=`netstat -nr |
                   grep -m1 default |
                   awk '{ if ($1 == "default") print $NF }'`

NETSET=`networksetup -listnetworkserviceorder |
        grep -m1 $DEFAULT_INTERFACE |
        awk '{ split($0, a, ":"); split(a[2], b, ","); print b[1] }' |
        sed -e 's/^[ \t]*//'`

ISENABLED=`networksetup -getwebproxy "$NETSET" |
           grep "^Enabled:" |
           awk -F': ' '{print $NF}'`


if [ "$OPERATION" == "setproxybypassdomains" ]; then
  DOMAINS=$2
  setProxyBypass $DOMAINS
else
  PORT=$1
  enableProxy $PORT
fi
